# copyright: Huynh Duong Phuong Vi
# www.sketchupforyou.com
module S4U
	module S4u_Hide_line
		def self.select_edges_elements(elements,edit_transform=axes_edit_transform.inverse)
			model = Sketchup.active_model
			element=elements[-1]
			entities=element.definition.entities
			edges=[]
			entities.each{|e|
				if e.is_a?Sketchup::Edge
					@edges<< [e,edit_transform*element.transformation,elements]
				elsif e.is_a?(Sketchup::Group) || e.is_a?(Sketchup::ComponentInstance)
					select_edges_elements (elements+[e]),(edit_transform*element.transformation)
				end
			}
			return @edges
		end
		def self.select_edges(element,edit_transform=axes_edit_transform.inverse)
			model = Sketchup.active_model
			entities=element.definition.entities
			edges=[]
			entities.each{|e|
				if e.is_a?Sketchup::Edge
					edges<< [e,edit_transform*element.transformation,element]
				elsif e.is_a?(Sketchup::Group) || e.is_a?(Sketchup::ComponentInstance)
					edges+=select_edges e,(edit_transform*element.transformation)
				end
			}
			return edges
		end
		def self.select_faces(element,edit_transform=axes_edit_transform.inverse)
			model = Sketchup.active_model
			entities=element.definition.entities
			faces=[]
			entities.each{|e|
				if e.is_a?Sketchup::Face
					faces<< [e,edit_transform*element.transformation,element]
				elsif e.is_a?(Sketchup::Group) || e.is_a?(Sketchup::ComponentInstance)
					faces+=select_faces e,(edit_transform*element.transformation)
				end
			}
			return faces
		end
		def self.axes_edit_transform
			model=Sketchup.active_model
			return ( Sketchup.version.to_i>=16) ? model.axes.transformation : model.edit_transform
		end
		def self.edge_in_element(edge_e,element,faces)
			model=Sketchup.active_model
			edge=[edge_e[0],edge_e[1],edge_e[2][-1]]
			tedit=axes_edit_transform
			edit_transform=edge[1]
			try_again=0
			points_edge=[edge[0].start.position.transform(edge[1]),edge[0].end.position.transform(edge[1])]
			bounds=element.is_a?(Sketchup::Group) ? element.local_bounds : element.definition.bounds
			if  bounds.contains?(points_edge[0].transform((element.transformation.inverse*tedit))) ||
				bounds.contains?(points_edge[1].transform((element.transformation.inverse*tedit))) ||
				faces.find{|f| Geom::intersect_line_plane(points_edge.collect{|p| p.transform(f[1].inverse)},f[0].plane)}
				#mats=edge[0].faces.collect{|e| e.material ?  e.material : edge[2].material }
				faces.each{|fa|
					#if mats.include?(fa[0].material ? fa[0].material : fa[2].material)
						points=points_edge.collect{|p| p.transform(fa[1].inverse)}
						pointonface=points.collect{|p| fa[0].classify_point(p)}
						mid=[(points[0].x+points[1].x)/2.0,(points[0].y+points[1].y)/2.0,(points[0].z+points[1].z)/2.0]
						mid_pointonface=fa[0].classify_point(mid)
						if (pointonface[0]==Sketchup::Face::PointInside ||
							pointonface[0]==Sketchup::Face::PointOnVertex ||
							pointonface[0]==Sketchup::Face::PointOnEdge) &&
						   (pointonface[1]==Sketchup::Face::PointInside ||
							pointonface[1]==Sketchup::Face::PointOnVertex ||
							pointonface[1]==Sketchup::Face::PointOnEdge ) &&
						   (mid_pointonface==Sketchup::Face::PointInside ||
							mid_pointonface==Sketchup::Face::PointOnVertex ||
							mid_pointonface==Sketchup::Face::PointOnEdge )
							if edge[0].faces.find{|f| f.normal.transform(edge[1]).samedirection?(fa[0].normal.transform(fa[1]))}
								return 2
							end
						elsif (pointonface[0]==Sketchup::Face::PointOutside) && (pointonface[1]==Sketchup::Face::PointOutside)
							fa[0].edges.each{|e|
								if e.line[1].length!=0 && (point=Geom::intersect_line_line(e.line,points)) &&
									(fa[0].classify_point(point)==Sketchup::Face::PointOnVertex ||
									fa[0].classify_point(point)==Sketchup::Face::PointInside ||
									fa[0].classify_point(point)==Sketchup::Face::PointOnEdge )
									@break_edge<<[edge[0].parent,point.transform(edit_transform.inverse*fa[1])]
									try_again=1
								end
							}
						elsif pointonface[0]==Sketchup::Face::PointInside ||
							pointonface[0]==Sketchup::Face::PointOnVertex ||
							pointonface[0]==Sketchup::Face::PointOnEdge
							if pointonface[1]==Sketchup::Face::PointOutside
								fa[0].edges.each{|e|
									if 	e.line[1].length!=0 && e.valid? && (point=Geom::intersect_line_line(e.line,points)) &&
										(fa[0].classify_point(point)==Sketchup::Face::PointOnVertex ||
										fa[0].classify_point(point)==Sketchup::Face::PointInside ||
										fa[0].classify_point(point)==Sketchup::Face::PointOnEdge )
										@break_edge<<[edge[0].parent,point.transform(edit_transform.inverse*fa[1])]
										try_again=1
									end
								}
							end
						elsif pointonface[1]==Sketchup::Face::PointInside ||
								pointonface[1]==Sketchup::Face::PointOnVertex ||
								pointonface[1]==Sketchup::Face::PointOnEdge
							if pointonface[0]==Sketchup::Face::PointOutside
								fa[0].edges.each{|e|
									if e.line[1].length!=0 && (point=Geom::intersect_line_line(e.line,points)) &&
										(fa[0].classify_point(point)==Sketchup::Face::PointOnVertex ||
										fa[0].classify_point(point)==Sketchup::Face::PointInside ||
										fa[0].classify_point(point)==Sketchup::Face::PointOnEdge )
										@break_edge<<[edge[0].parent,point.transform(edit_transform.inverse*fa[1])]
										try_again=1
									end
								}
							end
						end
					#end
				}
			end
			return try_again
		end
		def self.hide_line
			model=Sketchup.active_model
			selects=model.selection.to_a.select{|e| (e.is_a?(Sketchup::Group) or e.is_a?(Sketchup::ComponentInstance))}
			model.start_operation Strings.GetString(TOOL),true,false,false
			tedit=axes_edit_transform
			view=model.active_view
			@edges=[]
			@break_edge=[]
			@make_unique=nil
			(UI.messagebox(Strings.GetString("Select >=2 objects")) ;return) if selects.length<2
			selects=selects.repeated_combination(2).to_a.select{|e| e[0]!=e[1] }
			selects.each_index{|k|
				sels=selects[k]
				[selects[k],selects[k].reverse].each{|sels|
					next if sels[1].bounds.intersect(sels[0].bounds).diagonal==0
					try_again=true
					i=0
					max_times=2
					while i<max_times and (try_again)
						@edges=[]
						max_times=2 if @edges.length>2000
						j=1
						faces=select_faces(sels[1])
						select_edges_elements([sels[0]])
						if ((!@make_unique)) && @edges.find{|eds| eds[2].find{|e| e.definition.instances.length>1 }} #&& i==0
							@make_unique = UI.messagebox("Make Unique?",MB_YESNO)
						end
						if @make_unique==IDYES && i==0
							sels[0]=make_unique_element sels[0]
							@edges=[]
							select_edges_elements([sels[0]])
						end
						@edges.each_index{|ed_i|
							if @edges[ed_i][0].valid? && @edges[ed_i][0].is_a?(Sketchup::Edge) && !@edges[ed_i][0].hidden?
								Sketchup.status_text=(Strings.GetString("Processing Object") + " : " + (k+1).to_s + " - " +  j.to_s + "/" + @edges.length.to_s)
								j+=1
								@break_edge=[]
								result=edge_in_element @edges[ed_i],sels[1],faces
								if result==1
									try_again=true
									if !@break_edge.empty?
										@break_edge.each{|p| p[0].entities.add_edges(p[1],p[1])}
									end
								elsif result==2
									@edges[ed_i][0].hidden=true
								end
							end
						}
						i+=1
					end
				}
			}
			model.commit_operation
		end
		def self.make_unique_element(element)
			#if element.is_a?(Sketchup::Group) || (element.is_a?(Sketchup::ComponentInstance) && element.definition.instances.length>1)
				element=element.make_unique
				element.definition.entities.each{|e|
					self.make_unique_element(e) if e.is_a?(Sketchup::Group) || e.is_a?(Sketchup::ComponentInstance)
				}
			#end
			return element
		end
		def self.set_visual_line(hide,state)
			model=Sketchup.active_model
			ed=[]
			sels=[]
			model.selection.to_a.each{|e|
				if e.is_a?(Sketchup::Edge)
					ed<<e
				elsif e.is_a?(Sketchup::Face)
					ed+=e.edges
				elsif (e.is_a?(Sketchup::Group) or e.is_a?(Sketchup::ComponentInstance))
					sels<<e
				end
			}
			return if sels.empty? && ed.empty?
			make_unique=nil
			edges=[]
			sels.each{|e|
				@edges=[]
				select_edges_elements [e]
				edges+=@edges
			}
			if ((!make_unique)) && edges.find{|eds| eds[2].find{|e| e.definition.instances.length>1 }}
				make_unique = UI.messagebox("Make Unique?",MB_YESNO)
			end
			model.start_operation Strings.GetString(TOOL),true,false,false
			if make_unique==IDYES
				sels= sels.collect{|e| make_unique_element e}
			end
			edges=[]
			sels.each{|e| edges+=select_edges(e)}
			edges=edges.uniq{|e| e[0]}
			edges.each{|edge|
				edge[0].soft = state if (hide & 1)==1
				edge[0].smooth = state if (hide & 2)==2
				edge[0].hidden = state if (hide & 8)==8
			}
			ed.uniq!
			ed.each{|e|
				e.soft = state if (hide & 1)==1
				e.smooth = state if (hide & 2)==2
				e.hidden = state if (hide & 8)==8
			}
			model.commit_operation
		end
	class Select_Edge
		def initialize()
			cursor_path= File.join(File.dirname(__FILE__),(IS_OSX ? "icon_mouse.pdf" : "icon_mouse.svg"))
			@cursor_id_blue = UI.create_cursor(cursor_path, 0, 0)
			cursor_path= File.join(File.dirname(__FILE__),(IS_OSX ? "icon_mouse_red.pdf" : "icon_mouse_red.svg"))
			@cursor_id_red = UI.create_cursor(cursor_path, 0, 0)
		end
		def onSetCursor
			(@shift_press && @hide_mode!=3 && !@alt_press)? UI.set_cursor(@cursor_id_red) : UI.set_cursor(@cursor_id_blue)
		end
		def activate
			@selectedges=[]
			@moved_elements={}
			@strings=S4U::S4u_Hide_line::Strings
			@ip=Sketchup::InputPoint.new
			@ip_select=Sketchup::InputPoint.new
			@setting=S4U::S4u_Hide_line.class_variable_get :@@setting
			@hide_mode=@setting[0]
			@make_unique=(@setting[1]==1)
			@aperture=@setting[2]
			@hide_list=[@strings.GetString("Toggle Hide/Show Line"),@strings.GetString("Hide Line"),
					   @strings.GetString("Show Line"),@strings.GetString("Break Line"),@strings.GetString("Join Line")]
			self.reset(nil)
			self.setstatus(nil)
		end
		def deactivate(view)
			@setting=[@hide_mode,(@make_unique ? 1 : 0),@aperture]
			S4U::S4u_Hide_line.class_variable_set :@@setting,@setting
		end
		def axes_edit_transform
			model=Sketchup.active_model
			return ( Sketchup.version.to_i>=16) ? model.axes.transformation : model.edit_transform
		end
		def set_pointonedge(x,y,view,ip,edge)
			p1=edge.start.position.clone
			p2=edge.end.position.clone
			return nil if edge.length < (view.pixels_to_model(100, p1))
			points= [Geom.linear_combination(2.0/3, p1,1.0/3, p2),Geom.linear_combination(1.0/3, p1,2.0/3, p2)]
			ph = view.pick_helper
			ph.init(x, y)
			picked = points.find{|p| ph.test_point((p.transform ip.transformation),x,y,20) }
			if picked
				p=view.screen_coords(picked.transform ip.transformation)
				ip.pick view,p.x,p.y
				view.tooltip=@strings.GetString("1/3")
				return ip
			end
			return nil
		end
		def draw(view)
			if @ip && @ip.valid? && @ip.display?
				if @flags && !(@hide_mode==3 || @alt_press)
					view.draw_points @ip.position,@aperture,1
				end
				if @moved_elements.length>0
					if (@hide_mode==3 || @alt_press)
						if @point_edge
							view.draw_points @ip.position, 10, 1, "red"
						elsif @ip.display?
							@ip.draw(view)
							view.tooltip=@ip.tooltip
						end
					elsif (@hide_mode==3 && @alt_press) || (@hide_mode==4 && !@alt_press)
						if @ip.vertex
							view.draw_points @ip.position, 10, 1, "red"
							view.tooltip=@ip.tooltip
						end
					end
				end
			end
			if !@selectedges.empty?
				@selectedges.uniq{|ed| ed[0]}.each{|e| self.draw_over(view,e[0],e[1])}
			end
		end
		def draw_over(view,selectedge1,selectedge)
			if selectedge && selectedge1 && selectedge1.valid?
				if @ctrl_press
					view.drawing_color = (selectedge1.soft? && selectedge1.smooth?) ? "BlueViolet" : "Magenta"
				elsif @shift_press && !@alt_press && @hide_mode<3
					view.drawing_color = "Red"
				else
					view.drawing_color = selectedge1.hidden? ? "Orange" : "DarkBlue"
				end
				view.line_width = 5
				view.draw_line(selectedge[0],selectedge[1])
				if @ip && selectedge
					if @hide_mode>=3 || @alt_press
						@ip.draw view
						view.tooltip=@ip.tooltip if @shift_press
						if @point
							view.draw_points [@point], 10, 2, "red"
						else
							view.draw_points [@ip.position], 10, 2, "red"
						end
					end
				end
			end
		end
		def get_picked(ph_select,flags,view,x,y)
			ph_select.count.times { |index|
					if ph_select.leaf_at(index).is_a?Sketchup::Edge
						id=ph_select.element_at(index).entityID.to_s + "." + ph_select.leaf_at(index).entityID.to_s
						@moved_elements[id] =
						[ph_select.leaf_at(index),ph_select.element_at(index),ph_select.transformation_at(index),index]
					end
				}
			return @moved_elements
		end
		def get_edges
			selectedges=[]
			@moved_elements.values.each{|e|
				trans=e[2]
				selectedge=e[0]
				element=e[1]
				pstart=selectedge.start.position.clone.transform trans
				pend=selectedge.end.position.clone.transform trans
				p1=selectedge.start.position.clone.transform trans
				p2=selectedge.end.position.clone.transform trans
				ed=[p1,p2]
				selectedges<<[selectedge,ed,element,trans]
			}
			return selectedges
		end
		def onMouseMove(flags, x, y, view)
			@shift_press= (CONSTRAIN_MODIFIER_MASK&flags==CONSTRAIN_MODIFIER_MASK)
			@ctrl_press= (COPY_MODIFIER_MASK&flags==COPY_MODIFIER_MASK)
			@alt_press= (ALT_MODIFIER_MASK&flags==ALT_MODIFIER_MASK)
			@ip.pick view,x,y
			@point_edge=set_pointonedge(x,y,view,@ip,@ip.edge) if @ip.valid? && @ip.edge
			selectedge=nil
			element=nil
			@flags=((flags&1)==1)
			@ph_select = view.pick_helper
			@ph_select.do_pick(x, y,@aperture)
			if !((@hide_mode>=3||@alt_press) && @shift_press)
			# if ((@hide_mode>=3||@alt_press) && !@shift_press) || (@hide_mode<3 && !@alt_press)
				if @flags || @ph_select.picked_edge
					selectedge=@ph_select.picked_edge
					get_picked(@ph_select,flags,view,x,y)
					@selectedges=get_edges
				elsif !@flags
					@moved_elements.clear
					@selectedges.clear
				end
			end
			if (@hide_mode>=3 || @alt_press )
				if @shift_press && @edge_shift
					@point=@ip.position.project_to_line @edge_shift[1]
				elsif @ip.edge
					@point=nil
					pstart=@ip.edge.start.position.transform @ip.transformation
					pend=@ip.edge.end.position.transform @ip.transformation
					@edge_shift= [@ip.edge,[pstart,pend]]
				else
					@point=nil
					@edge_shift=nil
				end
			end
			Sketchup.vcb_label = @strings["Aperture(0-100)"]
			Sketchup.vcb_value = @aperture.to_s
			self.setstatus(view)
		end
		def getMenu(menu)
			hide_mode=[]
			@hide_list.each_index{|i|
				hide_mode<<menu.add_item(@hide_list[i]) { @hide_mode=i}
				menu.set_validation_proc(hide_mode[-1]){  MF_UNCHECKED }
			}
			menu.set_validation_proc(hide_mode[@hide_mode]){  MF_CHECKED }
			hide_mode=[]
			menu.add_separator
			hide_mode<<menu.add_item(@strings.GetString("Make Unique")) { @make_unique=!@make_unique }
			menu.set_validation_proc(hide_mode[0]){ @make_unique ? MF_CHECKED : MF_UNCHECKED}
		end
		def onLButtonUp(flags, x, y, view)
			@ip_select.copy! @ip
			@point_select=@point.clone if @point
			@selectedges=get_edges
			@selectedges.uniq!{|e| e[0]} if @hide_mode==0
			process view
			self.reset(view)
			self.setstatus
		end
		def onUserText(text, view)
			aperture=text.to_i
			@aperture=aperture if aperture>=0 && aperture<=100
		end
		def process view
			model=Sketchup.active_model
			model.start_operation Strings.GetString(TOOL),true,false,false
			if  !@selectedges.empty?
				process_line @selectedges
				@selectedges.clear
			end
			model.commit_operation
			rescue => error
			p error
			model.abort_operation
		end
		def process_line(selectedges)
			hide_mode=@hide_mode
			selectedges.each{|edge|
				selectedges1=[]
				selectedge1,selectedge,element,trans=edge
				if @make_unique
					if element && (element.is_a?(Sketchup::Group) || element.is_a?(Sketchup::ComponentInstance))
						element=S4U::S4u_Hide_line.make_unique_element element
						edges=S4U::S4u_Hide_line.select_edges element
						ed=edges.find_all{|e|
							(e[0].start.position.transform(e[1]).distance(selectedge[0])<=0.001) &&
							(e[0].end.position.transform(e[1]).distance(selectedge[1])<=0.001)
						}
						if ed
							ed.each{|e| selectedges1<< [e[0],selectedge,element,e[1]] }
						end
					end
				else
					selectedges1=[edge]
				end
				selectedges1.each{|eds|
					selectedge1=eds[0]
					trans=eds[3]
					if selectedge1
						if @ctrl_press
							selectedge1.soft = !selectedge1.soft?
							selectedge1.smooth = !selectedge1.smooth?
						elsif @shift_press	&& hide_mode!=3 && !@alt_press
							selectedge1.erase! if selectedge1 && selectedge1.valid?
							selectedge1=nil
						else
							if (hide_mode>=3||@alt_press)
								point=nil
								#trans=@ip_select.transformation
								if @shift_press && @point_select
									point=@point_select
								elsif @ip_select.valid?
									point=@ip_select.position
								end
								if point
									point=point.transform(trans.inverse)
									if (hide_mode==3 && @alt_press) || (hide_mode==4 && !@alt_press)
										vs=selectedge1.vertices.find_all{|e| e.position.distance(point)<=0.001}
										moves=[]
										vs.each{|v|
											if v && v.edges.length==2 && v.edges[0].line[1].length!=0 && v.edges[1].line[1].length!=0
												if v.edges[0].line[1].parallel? v.edges[1].line[1]
													e=selectedge1.other_vertex v
													vec= e.position-v.position
													moves<< [v,vec]
												end
											end
										}
										moves=moves.transpose.to_a
										selectedge1.parent.entities.transform_by_vectors(moves[0],moves[1]) if moves[0] && moves[0].length>0
									else
										selectedge1.split(point) if selectedge1 && selectedge1.valid?
									end
								end
							elsif hide_mode==0
								selectedge1.hidden = !selectedge1.hidden?
							elsif hide_mode==1
								selectedge1.hidden=true
							elsif hide_mode==2
								selectedge1.hidden=false
							end
						end
					end
				}
			}
		end
		def onKeyDown(key, repeat, flags, view)
			if ((key==VK_SHIFT) && IS_WIN ) || ((key==VK_SHIFT) && IS_OSX)
				@shift_press=true
				onSetCursor
				self.setstatus(view)
			elsif ((key==VK_CONTROL) && IS_WIN ) || ((key==VK_ALT) && IS_OSX)
				@ctrl_press=true
				self.setstatus(view)
			elsif ((key==VK_ALT) && IS_WIN ) || ((key==VK_CONTROL) && IS_OSX)
				@alt_press=true
				self.setstatus(view)
				return true
			end
		end
		def onKeyUp(key, repeat, flags, view)
			if ((key==VK_SHIFT) && IS_WIN ) || ((key==VK_SHIFT) && IS_OSX)
					@shift_press=nil
					onSetCursor
					self.setstatus(view)
			elsif ((key==VK_CONTROL) && IS_WIN ) || ((key==VK_ALT) && IS_OSX)
				@ctrl_press=nil
				self.setstatus(view)
			elsif ((key==VK_ALT) && IS_WIN ) || ((key==VK_CONTROL) && IS_OSX)
				@alt_press=nil
				self.setstatus(view)
				return true
			end
		end
		def onCancel(reason, view)
			self.reset(view)
		end
		def reset(view=nil)
			@ip.clear
			@ip_select.clear
			@moved_elements.clear
			@point_select=nil
			@ctrl_press=nil
			@shift_press=nil
			@alt_press=nil
			self.setstatus(view)
		end
		def setstatus(view=nil)
			text=@hide_list[@hide_mode] + " | "
			if IS_OSX
				text+=@strings.GetString("Select Line or Drag across | Hold Atl -> Soft-Smooth | Hold Shift -> Delete | Hold Control -> Break | Right Mouse -> Make Unique")
			else
				text+=@strings.GetString("Select Line or Drag across | Hold Ctrl -> Soft-Smooth | Hold Shift -> Delete | Hold Alt -> Break | Right Mouse -> Make Unique")
			end
			Sketchup.status_text=text
			view.invalidate if view
		end
		def resume(view)
			self.setstatus(view)
		end
		end
		def self.toggle_hide_line
			Sketchup.active_model.select_tool Select_Edge.new
		end
		@@setting=[0,0,5]
		def self.main(mode)
			if mode==0
				self.toggle_hide_line
			elsif mode==1
				self.hide_line
			elsif mode==2
				self.set_visual_line(8,true)
			elsif mode==3
				self.set_visual_line(8,false)
			end
		end
	end
end